Description

Task Details

1. Update Qauth 2.0 to replace accesskey way to connect with UPS

Input

e Email from UPS

Output

¢ Report and Solution

Others

History

#1 - 09/18/2024 04:21 PM - Junyi Zhang
- File0 000 OAuth API111 .docx added

#2 - 09/18/2024 04:21 PM - Junyi Zhang
- Start date changed from 02/18/2024 to 09/18/2024

#3 - 09/19/2024 06:23 PM - Junyi Zhang

- Status changed from 00 to0010

- % Done

changed from 0 to 30

Outputi 2024/09/19 - 2024/09/20)

1. Update Oauth 2.0 to replace accesskey way to connect with UPS

1.

About update to Restful (https:/developer.ups.com/oauth-developer-guide?loc=en_US)

- | decide to update UPS to restful API to replace the current way(XML).

- Even UPS supports the current way(soap/XML) to connect OAUTH2.0 by the steppingstone model, but the steppingstone model will also
be shut down in the future.

- The future UPS will have a transition about Resful, so we update it now instead of in the future.

. Update to Restful

1. Use UPS OAuth Client Credentials API to generate a token (Reference:
https://developer.ups.com/api/reference?loc=zh_CN Auth-Client-Credentials)
- Our project belongs to the client credentials type since we only use our ups account for tracking.
2. Use restful API's tracking function to replace the current XML way. https:/developer.ups.com/api/reference?loc=zh_CN#tag/Tracking
1. About the value of some ambiguous parameters that did not explained in APl document:
(Reference: https://github.com/UPS-APl/api-documentation/issues/15)
- transld: Unique transaction id, | use uniqid(rand(), true) to generate a unique id.
- transactionSrc: REDBLUE-OTS
3. Overrider UPS display function in order.js since the old(soap/XML) data structure won't fit the new(restful) structure
1. Add a new file: order.override.js (ui/desktop/js/order.override.js), and make it load later than order.js.
2. UPS data format:
- Old: Use js code to format data(location, date .etc)
- New: Use PHP to format data, js just display with the formatted data.
Change scope:
- protected/views/layouts/desktop.php
- protected/actions/track/QueryAction.php
- protected/tracking.ini
- protected/components/TrackingUPS.php
- (new)ui/desktop/js/order.tracking.ups.js

2. About UPS:
1. URL: https://developer.ups.com/apps/Redblue-OTS?loc=en_US
2. Settings:
Old:
ups_username = v533v8api
ups_password = ups.12345678
ups_access_key = ADCDI9DFOA2900ADS5
ups_test_mode = false
New:
ups_test_mode = false
ups_api_test_url = https://wwwcie.ups.com
ups_api_production_url = https://onlinetools.ups.com

ups_account_number = v533v8

ups_client_id = krDQOkgoTJGEzG1943X0gppaM6T8UcrnsaP jLLw3t69dg2MY

ups_client_secret = Ygf6BJEyZfLO9fAAKVRCMZvrYA307Z81ly7Cpc6CAIDNHkALPp4L1hCx6M6PCcGgUSOW

ups_grant_type = client_credentials // Our project belongs to the client credentials type since we onl

y use our ups account for tracking

#4 - 09/20/2024 07:16 PM - Junyi Zhang
- % Done changed from 30 to 90

#5 - 09/23/2024 12:57 PM - Junyi Zhang
- Subject changed from Update UPS Qauth 2.0 to Update UPS Oauth 2.0

#6 - 09/23/2024 02:46 PM - Junyi Zhang
- Status changed from 100 to0010
- % Done changed from 90 to 100

#7 - 10/08/2024 10:57 AM - Xihua Fan

- Target version set to v3.0
